//+------------------------------------------------------------------+
//|                                      PcntOfMarginToCloseAll.mq4  |
//|                                     Copyright  2007, Tradinator |
//|                                          tradinator.fx@gmail.com |
//+------------------------------------------------------------------+
//+-----------Sept 2008 - Changed to close all trades when percent of margin hit
#property copyright "Copyright  2007, Tradinator"
#property link      "tradinator.fx@gmail.com"


                                       
//extern double My_Money_Profit_Target=5;     //The amount of money profit at which you want to close ALL open trades.
extern int PcntOfMarginToCloseAll=50;                                  

int Slippage=6;
int c;
int PercentTP;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+


int start()
{
PercentTP=(AccountMargin()/100)*PcntOfMarginToCloseAll;
//if (AccountProfit()>= My_Money_Profit_Target)
if (AccountProfit()>=PercentTP)
   {
    for(c=OrdersTotal()-1;c>=0;c--)
       {
       OrderSelect(c, SELECT_BY_POS);
       int type   = OrderType();
               
       bool result = false;
              
       switch(type)
          {
      //Close opened long positions
      case OP_BUY       : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID),Slippage, Red );
                          break;
      
      //Close opened short positions
      case OP_SELL      : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK),Slippage, Red );
                          break;

      //Close pending orders
      case OP_BUYLIMIT  :
      case OP_BUYSTOP   :
      case OP_SELLLIMIT :
      case OP_SELLSTOP  : result = OrderDelete( OrderTicket() );
                         
          }
          
       if(result == false)
          {
            Sleep(3000);
          }  
       }
      Print ("Account Profit Reached. All Open Trades Have Been Closed");
      return(0);
   }  
   
   Comment("Balance: ",AccountBalance(),", Account Equity: ",AccountEquity(),", Account Profit: ",AccountProfit(),
           "\nMy Account Profit Target: ",(AccountMargin()/100)*PcntOfMarginToCloseAll);
   
  return(0);
}


